#ifndef TCORDFERCALIBBRANCH_HH_
#define TCORDFERCALIBBRANCH_HH_

#include <iostream>
#include <vector>

#include <TSystem.h>

using namespace std;

class TCordferCalibBranch
{
  private:
    TString name;

  public:
    TCordferCalibBranch(){}
    TCordferCalibBranch(TString bname){
      name = bname;
    }
    ~TCordferCalibBranch(){}

    bool adc;
    Int_t geo;
    Int_t ch;
    Int_t calib_dim;
    Int_t count_hit;
    Double_t cbra_val;
    Double_t cbra_tval[12];
    vector<Double_t> calib_param;

    //for MUX
    bool mux_status1;
    bool mux_status2;
    bool mux_pos1;
    bool mux_pos2;
    bool mux1_junk;
    bool mux2_junk;
    Int_t mux_ch1;
    Int_t mux_ch2;
    Int_t geo_tmp1;
    Int_t geo_tmp2;
    Int_t ch_tmp1;
    Int_t ch_tmp2;
    Int_t val_tmp1;
    Int_t val_tmp2;
    vector<Double_t> mpos1_prm;
    vector<Double_t> mpos2_prm;

    TString GetBranchName(){ return name; }

    void SetGeometrytmp1(Int_t geo, Int_t ch, Int_t val){
      geo_tmp1 = geo;
      ch_tmp1 = ch;
      val_tmp1 = val;
    }
    void SetGeometrytmp2(Int_t geo, Int_t ch, Int_t val){
      geo_tmp2 = geo;
      ch_tmp2 = ch;
      val_tmp2 = val;
    }

    void CopyCalibInfo(Int_t dim, vector<Double_t> param);
};

#endif
