#include <iostream>
#include <fstream>
#include <sstream>
#include <string>
#include <vector>

#include <TSystem.h>

#include <ChannelMap.hh>

using namespace std;


void ChannelMap::ReadMap() {
  ifstream fin(filename.Data());
  string buf;

  while(getline(fin, buf)){
    if(buf[0]=='#' || buf[0]=='c'){ continue; }
    if(buf.find("N/A") != string::npos){ continue; }

    vector<int> line;
    vector<Int_t> id, ch;

    if((buf.find(';') != buf.rfind(';')) || buf.find(';') == string::npos){
      cerr << "ERROR: map file is not correct" << endl;
      exit(0);
    }
    string name = buf.substr(buf.find(';')+1);
    if(name[0] == ' '){ name.erase(0, 1); }
    if(name[name.length()-1] == ' '){ name.pop_back(); }
    replace(name.begin(), name.end(), ' ', '_');
    replace(name.begin(), name.end(), '/', '_');
    replace(name.begin(), name.end(), '-', '_');

    while(buf.find(',') != string::npos){
      int pos = buf.find(',');
      string tmp = buf.substr(0, pos);
      if(tmp[0] == ' '){ tmp.erase(0, 1); }
      if(tmp[tmp.length()-1] == ' '){ tmp.pop_back(); }
      if(tmp.find(' ') == string::npos){
        buf.erase(0, pos+1);
        continue;
      }
      stringstream ss{tmp};
      string val;
      while(getline(ss, val, ' ')){
        if(val == ""){ continue; }
        int i_val = stoi(val);
        line.push_back(i_val);
      }
      id.push_back(line[3]);
      ch.push_back(line[4]);
      line.clear();
      buf.erase(0, pos+1);
    }

    segment_id.push_back(id);
    channel.push_back(ch);
    detector_name.push_back(name);
    size++;
  }
  fin.close();
}


void ChannelMap::ReadMap(TString in_filename){
  SetMapFile(in_filename);
  ReadMap();
}
